
;v2
; startcd.narod.ru
; 4    

.include "tn15def.inc"
;.include "C:\VMLAB\include\TN15DEF.INC"

; //  3- 


;PB2 button int0
;PB1 OCR1A


.def NOL		=	r1
.def sreg_save	=	r2
.def store_ocr	=	r3
.def current_ocr=	r5

.def tmp		=	r16
.def var_4		=	r17

.def Time_10ms	=	r27
.def var_3		=	r28
.def var_1		=	r29
.def var_2		=	r30
.def Flag		=	r31


.equ BTN		=	PB2
.equ FL_current_polling 	=	2
.equ FREG_PWM	=	200 ;  

;//--------EEPROM----------
.equ EEP_OCR 		= 	1
.equ EEP_U_ALARM	=	2





; ***** INTERRUPT VECTORS *************************************
.org 0
rjmp 	reset
reti	;rjmp	INT0_interrupt	; External Interrupt 0
rjmp	reset;PCI0_interrupt	; External Interrupt Request 0
rjmp	reset;OC1_interrupt	; Timer/Counter1 Compare Match
rjmp	reset;OVF1_interrupt	; Timer/Counter1 Overflow
rjmp	reset;OVF0_interrupt	; Timer/Counter0 Overflow
rjmp	reset;ERDY_interrupt	; EEPROM Ready
rjmp	reset;ACI_interrupt	; Analog Comparator
rjmp	reset;ADCC_interrupt	; ADC Conversion Ready



;//************************************************************
reset:
	ldi	tmp, 0
	mov NOL, tmp
	mov var_1, NOL	
	mov var_2, NOL	
	mov var_3, NOL	
	mov var_4, NOL	
	mov current_ocr, NOL
	mov Flag, NOL
	mov Time_10ms, NOL

	out PORTB, 	NOL
	out	DDRB,	NOL
	
;init_port:	;------------------------------------------
	sbi DDRB, PB1;	//  PB1 (AIN1/MISO/OC1A)  
	sbi PORTB, BTN;	//    ,  

;init_timer1:	;------------------------------------------
	ldi tmp, FREG_PWM ;150 kHz  
	out	OCR1B, tmp;

;init_komporator:	;------------------------------------------
	ldi tmp, 1<<ACD; off
	out ACSR, tmp;

;init_data:	;------------------------------------------
;	sbic EECR,EEWE
;	rjmp init_data
	ldi tmp, EEP_OCR
	out EEAR, tmp
	sbi EECR,EERE; Start eeprom read by writing EERE
	in tmp,EEDR; Read data from data register
		cpi tmp, FREG_PWM-15;//  F,    ,  
		brlo data_ok
		ldi tmp, FREG_PWM-15;
	data_ok:
	mov store_ocr, tmp;// 


;//**********************************************************
;//------------------- -------------------
main:
	clr current_ocr;
	out TCCR0, NOL; //  
	ldi tmp, 1<<FOC1A
	out SFIOR, tmp	;	     
	out TCCR1, NOL;
	
	ldi tmp, 1<<INTF0
	out GIFR, tmp
	;ldi tmp, 1<<INT0
	out GIMSK, tmp
	
	SEI;
	ldi tmp, (1<<SM1)|(0<<SM0)|(1<<SE)|(0<<ISC01)|(0<<ISC00);// Power down mode
	out MCUCR, tmp;
	
	;----------
	sleep
	CLI
	;----------
	OUT MCUCR, NOL

;	ldi tmp, (0<<CS02)|(1<<CS01)|(0<<CS00); //  
	ldi tmp, (1<<CS02)|(0<<CS01)|(0<<CS00); //  
	out TCCR0, tmp;
	
	;ldi tmp, 0	;   
	out OCR1A, NOL
	ldi tmp, (1<<COM1A1)|(0<<COM1A0)|(1<<PWM1)|(0<<CS13)|(0<<CS12)|(0<<CS11)|(1<<CS10);
	out TCCR1, tmp;

	ldi var_1, 1;	,  10mSek
	rcall wait_time_10mS_mul_var_1	

	
;//-----------      	------------
	rcall init_wait_function;
	ldi var_1, 150;   

;-----------------------------------
wait_up_btn:
	
	rcall boolean_test_time10mS
		cpi var_4, 1	
		breq set_regim_prog	;       .
			
test_btn:
	sbis PINB, BTN			;  
	rjmp wait_up_btn		;  ,      .
;-----------------------------------

	ldi var_1, 10;	 10mSek
	rcall wait_time_10mS_mul_var_1	


;-----------------------   ------------------------------	
; 
	ldi tmp, 4
	mov current_ocr, tmp
	out OCR1A, tmp
	
	clr Flag
	rcall init_wait_function;
	ldi var_1, 4;   

;-----------------------------------
WORK_REGIM:
	sbrc Flag, FL_current_polling	;    
	rjmp no_event_time				;    
 	
	rcall boolean_test_time10mS
		cpi var_4, 1
		brne no_event_time
		
		;in tmp, OCR1A	;  
		inc current_ocr
		out OCR1A, current_ocr;
		;ldi r19, FREG_PWM-15;
		cp current_ocr, store_ocr	;     OCR1A
		brne no_event_time	;

		sbr Flag, 1<<FL_current_polling;

no_event_time: 	
	sbis PINB, BTN		;   ?
	rjmp off_light		;  ,   		
	rjmp WORK_REGIM		;        .		
;-----------------------------------


;--------------------------------------------------------------------
;   
set_regim_prog:

	ldi var_4, 4
;-----------------------------------
; 
indikation_input:
	mov tmp, store_ocr;FREG_PWM>>1
	lsr tmp
	dec var_4
	sbrs var_4, 0
	ldi tmp, 0
	out OCR1A, tmp
	
	cpi var_4, 0
	breq in_light_change; , 

	ldi var_1, 20;   	
	rcall wait_time_10mS_mul_var_1;	
	rjmp indikation_input
;-----------------------------------	

in_light_change:;     
	sbis PINB, BTN
	rjmp in_light_change
	
;-----------------------------------
;      ,    
light_change:
	out OCR1A, NOL
	clr current_ocr

inc_light:
	ldi var_1, 5
	rcall wait_time_10mS_mul_var_1
		
	;in tmp, OCR1A	;  
		inc current_ocr
		;inc tmp
		ldi var_2, FREG_PWM-10;
		cp current_ocr, var_2	;     OCR1A
		brsh light_change	;    	
		out OCR1A, current_ocr;
	
	sbis PINB, BTN;   ?
	rjmp save_ocr
	rjmp inc_light
;-----------------------------------
;         
save_ocr:
	mov  var_1, current_ocr
	ldi var_2, EEP_OCR
	mov store_ocr, current_ocr
	out OCR1A, NOL;
	rcall EEPROM_write;


	out OCR1A, NOL
	ldi var_1, 50
	rcall wait_time_10mS_mul_var_1
	
	out OCR1A, store_ocr
	ldi var_1, 150
	rcall wait_time_10mS_mul_var_1	

	out OCR1A, NOL

rjmp main

;--------------------------------------------------------------------
;  
off_light:
	ldi var_1, 4
	rcall wait_time_10mS_mul_var_1

	cp current_ocr, NOL
	breq off_light_ok

	dec current_ocr
	out OCR1A, current_ocr
	
	mov tmp, store_ocr
	lsr tmp
	;lsr tmp
	;mov var_1, tmp
	;lsr var_1
	;add tmp, var_1
	cp current_ocr, tmp
	brne _dec
		ldi var_1, 250
		rcall wait_time_10mS_mul_var_1
		ldi var_1, 250
		rcall wait_time_10mS_mul_var_1

_dec:	
	cp current_ocr, NOL
	brne off_light;

	out OCR1A, NOL
	
off_light_ok:
rjmp main


;//**********************************************************
;   
init_wait_function:
	clr Time_10ms	
	ldi var_3, 1<<PSR0
	out SFIOR, var_3
	ldi var_3, 0xFF-63;    TCNT   
	out TCNT0, var_3
	ldi var_2, 1<<TOV0
	out TIFR, var_2;   
	ret

;/***********************************************************	
wait_time_10mS_mul_var_1:
;var_1	-  - 
;var_2  -     timer0
;var_3  -     TCNT0

	rcall init_wait_function;

	w007:;//
	in tmp, TIFR
	sbrs tmp, TOV0
	rjmp w007
		out TIFR,  var_2;   
		out TCNT0, var_3;    TCNT   
		inc Time_10ms;
		cp Time_10ms, var_1;
		brne w007;
	ret

;//**********************************************************
boolean_test_time10mS:
;var_1	-  - 
;var_2  -     timer0
;var_3  -     TCNT0
;var_4  -   1-true 0-false
	ldi var_4, 0
	in tmp, TIFR
	sbrs tmp, TOV0
	rjmp quit_bool_test
		out TIFR,  var_2;   
		out TCNT0, var_3;    TCNT   
		inc Time_10ms;
		cp Time_10ms, var_1;
		brne quit_bool_test
   	clr Time_10ms
   	ldi var_4, 1; end
	quit_bool_test:
	ret

;//**********************************************************
; var_2 - adress
; var_1 - 
EEPROM_write:
	; Wait for completion of previous write
	sbic EECR,EEWE
	rjmp EEPROM_write
	
	out EEAR, var_2; var_2 - adress
	out EEDR, var_1; var_1 - 

	
	sbi EECR,EEMWE; Write logical one to EEMWE
	sbi EECR,EEWE; Start eeprom write by setting EEWE
	ret
;//**********************************************************

















